import * as process from "node:process";
import { type ILogObj, Logger } from "tslog";

export class LogsUtils {
	private Logger: Logger<ILogObj>;
	constructor(contextName: string) {
		this.Logger = new Logger({
			name: contextName,
			prettyLogTimeZone: `local`
		});
	}

	info(value: any, value2?: any) {
		this.Logger.info(
			`\n\n(i) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
		);
	}

	warn(value: any, value2?: any) {
		this.Logger.warn(
			`\n\n(?) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
		);
	}

	error(value: any, value2?: any) {
		this.Logger.error(
			`\n\n(!) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
		);
		if (process.env["CONTEXT"] === "prod") process.exit(-1);
	}

	softError(value: any, value2?: any) {
		this.Logger.error(
			`\n\n(!) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
		);
	}

	trace(value: any, value2?: any) {
		if (process.env["DEBUG"] === "true")
			this.Logger.trace(
				`\n\n(*) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
			);
	}

	fatal(value: any, value2?: any) {
		this.Logger.fatal(
			`\n\n(X) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
		);
		if (process.env["CONTEXT"] === "prod") process.exit(-1);
	}

	debug(value: any, value2?: any) {
		if (process.env["DEBUG"] === "true")
			this.Logger.debug(
				`\n\n(~) > ${value}\n${value2 ? "> " + value2 + "\n" : ""}`,
			);
	}
}
