const Validators = {
	isEmail: (value: string) => {
		const emailRegex = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/;
		return emailRegex.test(value)
	},
	isUsername: (value: string) => {
		const usernameRegex = /^[a-zA-Z0-9._]{3,16}$/;
		return usernameRegex.test(value);
	},

	isPassword: (value: string) => {
		const passwordRegex = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[@$!%*?&])[A-Za-z\d@$!%*?&]{8,}$/;
		return passwordRegex.test(value);
	}
}

export default Validators